diff -r 82fcd4bea972 src/mn.h
--- a/src/mn.h	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/mn.h	Fri Jan 11 17:02:25 2008 +0100
@@ -52,6 +52,7 @@ struct ha_candidate_list {
 #define	NEMO_FWD_BLOCK	0x10
 
 struct mn_addr {
+	struct list_head list;
 	struct in6_addr addr;
 	int iif;
 	struct timespec timestamp;
@@ -75,7 +76,8 @@ struct home_addr_info {
 	uint8_t home_plen;
 	struct in6_addr home_prefix;
 	struct hash bul; /* Binding Update List */
-	struct mn_addr primary_coa;
+	struct mn_addr *current_coa; /* MCoA: pointer to a member of mcoa */
+	struct list_head mcoa; /* MCoA: list of all active CoAs */
 	struct list_head ro_policies;
 	struct ha_candidate_list ha_list;	
 	struct in6_addr ha_addr;
@@ -84,9 +86,11 @@ struct home_addr_info {
 	int if_tunnel;
 	int if_home;
 	int if_block;
+	int table; /* MCoA: routing table number where routes are stored */
 	short hwalen;
 	uint8_t altcoa;
 	uint16_t mob_rtr;
+	uint8_t reg_mcoa;
 	char name[IF_NAMESIZE];
 	int mnp_count;
 	struct list_head mob_net_prefixes;
diff -r 82fcd4bea972 src/movement.c
--- a/src/movement.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/movement.c	Fri Jan 11 17:02:25 2008 +0100
@@ -165,7 +165,7 @@ static void md_prefix_rule_del(struct pr
 	struct in6_addr prefix;
 	ipv6_addr_prefix(&prefix, &p->ple_prefix, p->ple_plen);
 	rule_del(NULL, RT6_TABLE_MAIN, IP6_RULE_PRIO_MIP6_COA_OUT,
-		 RTN_UNICAST, &prefix, p->ple_plen,
+		 0, RTN_UNICAST, &prefix, p->ple_plen,
 		 &in6addr_any, 0, 0);
 }
 
@@ -312,10 +312,10 @@ static void md_expire_router(struct md_i
 
 static void md_block_rule_del(struct md_inet6_iface *iface)
 {
-	rule_del(NULL, 0, IP6_RULE_PRIO_MIP6_BLOCK_HOA, RTN_BLACKHOLE,
+ 	rule_del(NULL, 0, IP6_RULE_PRIO_MIP6_BLOCK_HOA, 0, RTN_BLACKHOLE,
 		 &in6addr_any, 0, &in6addr_any, 0, 0);
-	rule_del(NULL, RT6_TABLE_MAIN, IP6_RULE_PRIO_MIP6_COA_OUT, RTN_UNICAST,
-		 &in6addr_any, 128, &in6addr_any, 0, 0);
+ 	rule_del(NULL, RT6_TABLE_MAIN, IP6_RULE_PRIO_MIP6_COA_OUT, 0, 
+		 RTN_UNICAST, &in6addr_any, 128, &in6addr_any, 0, 0);
 	iface->iface_flags &= ~MD_BLOCK_TRAFFIC;
 }
 
@@ -1290,7 +1290,7 @@ static void md_prefix_rule_add(struct pr
 	struct in6_addr prefix;
 	ipv6_addr_prefix(&prefix, &p->ple_prefix, p->ple_plen);
 	rule_add(NULL, RT6_TABLE_MAIN, IP6_RULE_PRIO_MIP6_COA_OUT,
-		 RTN_UNICAST, &prefix, p->ple_plen,
+		 0, RTN_UNICAST, &prefix, p->ple_plen,
 		 &in6addr_any, 0, 0);
 }
 
@@ -1361,13 +1361,13 @@ static int md_block_rule_add(struct md_i
 	iface->iface_flags |= MD_BLOCK_TRAFFIC;
 	/* Allow DAD probes and RS messages */
 	rule_add(NULL, RT6_TABLE_MAIN,
-		 IP6_RULE_PRIO_MIP6_COA_OUT, RTN_UNICAST,
+ 		 IP6_RULE_PRIO_MIP6_COA_OUT, 0, RTN_UNICAST,
 		 &in6addr_any, 128, &in6addr_any, 0, 0);
 	/* drop outgoing global traffic until DAD has been performed
 	   on CoA to make routing and tunnel end-point updates atomic
 	   during handoff */
 	return rule_add(NULL, 0,
-			IP6_RULE_PRIO_MIP6_BLOCK_HOA, RTN_BLACKHOLE,
+ 			IP6_RULE_PRIO_MIP6_BLOCK_HOA, 0, RTN_BLACKHOLE,
 			&in6addr_any, 0, &in6addr_any, 0, 0);
 }
 
diff -r 82fcd4bea972 src/mpdisc_ha.c
--- a/src/mpdisc_ha.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/mpdisc_ha.c	Fri Jan 11 17:02:25 2008 +0100
@@ -68,7 +68,7 @@ static inline struct mpa_entry *mpa_get(
 					const struct in6_addr *hoa)
 					
 {
-	return hash_get(&mpa_hash, ha, hoa);
+	return hash_get(&mpa_hash, ha, hoa, 0);
 }
 
 /* HA functions */
@@ -214,7 +214,7 @@ void mpd_cancel_mpa(const struct in6_add
 	pthread_mutex_lock(&mpa_lock);
 	e = mpa_get(ha, hoa);
 	if (e != NULL) {
-		hash_delete(&mpa_hash, &e->ha, &e->hoa);
+		hash_delete(&mpa_hash, &e->ha, &e->hoa, 0);
 		if (tsisset(e->delay))
 			del_task(&e->tqe);
 		free(e);
@@ -239,7 +239,7 @@ int mpd_start_mpa(const struct in6_addr 
 		memset(e, 0, sizeof(struct mpa_entry));
 		e->ha = *ha;
 		e->hoa = *hoa;
-		if (hash_add(&mpa_hash, e, &e->ha, &e->hoa)) {
+		if (hash_add(&mpa_hash, e, &e->ha, &e->hoa, NULL)) {
 			free(e);
 			goto out;
 		}
diff -r 82fcd4bea972 src/mpdisc_mn.c
--- a/src/mpdisc_mn.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/mpdisc_mn.c	Fri Jan 11 17:02:25 2008 +0100
@@ -65,7 +65,7 @@ static inline struct mps_entry *mps_get(
 static inline struct mps_entry *mps_get(const struct in6_addr *hoa,
 					const struct in6_addr *ha)
 {
-	return hash_get(&mps_hash, hoa, ha);
+	return hash_get(&mps_hash, hoa, ha, 0);
 }
 
 #ifdef ENABLE_VT
@@ -116,7 +116,7 @@ void mpd_cancel_mps(const struct in6_add
 	e = mps_get(hoa, ha);
 	if (e != NULL) {
 		dbg("canceling MPS\n");
-		hash_delete(&mps_hash, &e->hoa, &e->ha);
+		hash_delete(&mps_hash, &e->hoa, &e->ha, 0);
 		if (tsisset(e->delay))
 			del_task(&e->tqe);
 		free(e);
@@ -175,7 +175,7 @@ int mpd_schedule_first_mps(const struct 
 		memset(e, 0, sizeof(struct mps_entry));
 		e->hoa = *hoa;
 		e->ha = *ha;
-		if (hash_add(&mps_hash, e, &e->hoa, &e->ha)) {
+		if (hash_add(&mps_hash, e, &e->hoa, &e->ha, NULL)) {
 			free(e);
 			goto out;
 		}
diff -r 82fcd4bea972 src/ndisc.h
--- a/src/ndisc.h	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/ndisc.h	Fri Jan 11 17:02:25 2008 +0100
@@ -21,6 +21,7 @@ static inline short nd_get_l2addr_len(un
 		return 1;
 		/* supported virtual devices */
 	case ARPHRD_SIT:
+		return 4;
 	case ARPHRD_TUNNEL6:
 	case ARPHRD_PPP:
 	case ARPHRD_IPGRE:
diff -r 82fcd4bea972 src/policy.c
--- a/src/policy.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/policy.c	Fri Jan 11 17:02:25 2008 +0100
@@ -47,6 +47,25 @@ pthread_rwlock_t policy_lock;
 pthread_rwlock_t policy_lock;
 struct hash policy_bind_acl_hash;
 int def_bind_policy = IP6_MH_BAS_PROHIBIT;
+
+/**
+ * default_mcoa_reg - Check if MCoA reg is allowed
+ * @remote_hoa: remote MN's home address
+ *
+ * Returns 0 if not allowed, 1 if allowed.
+ **/
+int default_mcoa_reg(const struct in6_addr *remote_hoa) 
+{
+	struct policy_bind_acl_entry *acl;
+	int ret = 1;
+
+	pthread_rwlock_rdlock(&policy_lock);
+	acl = hash_get(&policy_bind_acl_hash, NULL, remote_hoa, 0);
+	if (!conf.HaAcceptMCoAReg || (acl && !acl->mcoa_reg))
+		ret = 0;
+	pthread_rwlock_unlock(&policy_lock);
+	return ret;
+}
 
 /**
  * default_best_iface - select best interface during handoff
@@ -148,7 +167,7 @@ int default_discard_binding(const struct
 		return IP6_MH_BAS_MR_OP_NOT_PERMITTED;
 
 	pthread_rwlock_rdlock(&policy_lock);
-	acl = hash_get(&policy_bind_acl_hash, NULL, remote_hoa);
+	acl = hash_get(&policy_bind_acl_hash, NULL, remote_hoa, 0);
 	if (acl != NULL) {
 		ret = acl->bind_policy;
 		if (ret < IP6_MH_BAS_UNSPECIFIED &&
@@ -213,8 +232,16 @@ int default_accept_inet6_iface(int iif)
 		struct net_iface *nif;
 		nif = list_entry(list, struct net_iface, list);
 		if (nif->ifindex == iif) {
-			if (is_if_mn(nif)) 
-				return nif->mn_if_preference;
+			if (is_if_mn(nif)) {
+				/* MCoA 
+				 * Return the BID Priority if the 
+				 * interface preference is 0
+				 */
+				if(nif->mn_if_preference)
+					return nif->mn_if_preference;
+				else
+					return nif->mn_if_bidprio;
+			}
 			return 0;
 		}
 	}
@@ -259,7 +286,7 @@ int default_get_mnp_count(const struct i
 	int ret = 0;
 	struct policy_bind_acl_entry *acl;
 	pthread_rwlock_rdlock(&policy_lock);
-	acl = hash_get(&policy_bind_acl_hash, NULL, hoa);
+	acl = hash_get(&policy_bind_acl_hash, NULL, hoa, 0);
 	if (acl != NULL)
 		ret = acl->mnp_count;
 	pthread_rwlock_unlock(&policy_lock);
@@ -275,7 +302,7 @@ int default_get_mnps(const struct in6_ad
 	struct policy_bind_acl_entry *acl;
 
 	pthread_rwlock_rdlock(&policy_lock);
-	acl = hash_get(&policy_bind_acl_hash, NULL, hoa);
+	acl = hash_get(&policy_bind_acl_hash, NULL, hoa, 0);
 	if (acl != NULL) {
 		struct list_head *l;
 		list_for_each(l, &acl->mob_net_prefixes) {
@@ -314,7 +341,7 @@ static int policy_bind_acl_add(struct po
 static int policy_bind_acl_add(struct policy_bind_acl_entry *acl)
 {
 	int err;
-	err = hash_add(&policy_bind_acl_hash, acl, NULL, &acl->hoa);
+	err = hash_add(&policy_bind_acl_hash, acl, NULL, &acl->hoa, NULL);
 	if (!err) {
 		list_del(&acl->list);
 	}
diff -r 82fcd4bea972 src/policy.h
--- a/src/policy.h	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/policy.h	Fri Jan 11 17:02:25 2008 +0100
@@ -6,7 +6,13 @@
 #include <netinet/in.h>
 #include "list.h"
 
-#define POL_MN_IF_DEF_PREFERENCE 5
+/* MCoA 
+ * Changed POL_MN_IF_DEF_PREFERENCE from 5 to 0
+ */
+#define POL_MN_IF_DEF_PREFERENCE 0
+#define POL_MN_IF_DEF_BID 0
+#define POL_MN_IF_DEF_BID_PRIORITY 0
+#define POL_MN_IF_DEF_RELIABLE 1
 
 struct ip6_mh_binding_update;
 struct nd_router_advert;
@@ -17,9 +23,18 @@ struct policy_bind_acl_entry {
 	struct in6_addr hoa;
 	int plen;
 	int bind_policy;
+	int mcoa_reg;
 	int mnp_count;
 	struct list_head mob_net_prefixes;
 };
+
+/**
+ * default_mcoa_reg - Check if MCoA registration is allowed
+ * @remote_hoa: remote MN's home address
+ * 
+ * Returns 0 if not allowed, 1 if allowed.
+ **/
+int default_mcoa_reg(const struct in6_addr *remote_hoa);
 
 /**
  * default_best_iface - select best interface during handoff
diff -r 82fcd4bea972 src/retrout.c
--- a/src/retrout.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/retrout.c	Fri Jan 11 17:02:25 2008 +0100
@@ -151,7 +151,7 @@ static struct rrlentry *rre_create(int t
 	rre->own2 = *own2;
 	rre->iif = iif;
 
-	if (hash_add(&rrl_hash, rre, &rre->own1, &rre->peer) < 0) {
+	if (hash_add(&rrl_hash, rre, &rre->own1, &rre->peer, NULL) < 0) {
 		rrl_delete(rre);
 		return NULL;
 	}
@@ -168,7 +168,7 @@ static struct rrlentry *rrl_get(int type
 
 	assert(our_addr);
 
-	rre = (struct rrlentry *)hash_get(&rrl_hash, our_addr, peer_addr);
+	rre = (struct rrlentry *)hash_get(&rrl_hash, our_addr, peer_addr, 0);
 
 	if (rre != NULL && rre->type != type)
 		return NULL;
@@ -188,7 +188,7 @@ static void rrl_delete(struct rrlentry *
 	TRACE;
 
 	del_task(&rre->tqe);
-	hash_delete(&rrl_hash, &rre->own1, &rre->peer);
+	hash_delete(&rrl_hash, &rre->own1, &rre->peer, 0);
 
 	if (rre->type == COT_ENTRY) {
 		struct list_head *list, *n;
@@ -629,7 +629,7 @@ int mn_rr_error_check(const struct in6_a
 		      const struct in6_addr *peer,
 		      struct in6_addr *hoa)
 {
-	struct rrlentry *rre = hash_get(&rrl_hash, own, peer);
+	struct rrlentry *rre = hash_get(&rrl_hash, own, peer, 0);
 
 	if (rre == NULL || !rre->wait)
 		return 0;
@@ -694,7 +694,11 @@ static void mn_recv_cot(const struct ip6
 		struct addr_holder *ah;
 
 		ah = list_entry(list, struct addr_holder, list);
-		bule = bul_get(NULL, &ah->addr, cn_addr);
+		/* MCoA TODO2
+		 * MCoA does not work with RR
+		 * At the moment the first entry that match is chosen
+		 */
+		bule = bul_get(NULL, &ah->addr, cn_addr, MCOA_NO_BID);
 
 		if (bule == NULL || bule->type != BUL_ENTRY ||
 		    !IN6_ARE_ADDR_EQUAL(&rre_co->own1, &bule->coa)) {
@@ -774,7 +778,11 @@ static void mn_recv_hot(const struct ip6
 		pthread_rwlock_unlock(&mn_lock);
 		return;
 	}
-	bule = bul_get(NULL, home_addr, cn_addr);
+	/* MCoA TODO2
+	 * MCoA does not work with RR
+	 * At the moment the first entry that match is chosen
+	 */
+	bule = bul_get(NULL, home_addr, cn_addr, MCOA_NO_BID);
 
 	if (bule == NULL || bule->type != BUL_ENTRY) {
 		rrl_delete(rre_ho);
diff -r 82fcd4bea972 src/rtnl.c
--- a/src/rtnl.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/rtnl.c	Fri Jan 11 17:02:25 2008 +0100
@@ -299,7 +299,7 @@ int route_del(int oif, uint8_t table, ui
 }
 
 static int rule_mod(const char *iface, int cmd, uint8_t table,
-		    uint32_t priority, uint8_t action,
+		    uint32_t priority, uint32_t fwmark, uint8_t action,
 		    const struct in6_addr *src, int src_plen,
 		    const struct in6_addr *dst, int dst_plen, int flags)
 {
@@ -331,6 +331,8 @@ static int rule_mod(const char *iface, i
 		addattr_l(n, sizeof(buf), RTA_SRC, src, sizeof(*src));
 	if (priority)
 		addattr32(n, sizeof(buf), RTA_PRIORITY, priority);
+	if (fwmark)
+		addattr32(n, sizeof(buf), RTA_PROTOINFO, fwmark);
 	if (iface)
 		addattr_l(n, sizeof(buf), RTA_IIF, iface, strlen(iface) + 1);
 
@@ -349,12 +351,12 @@ static int rule_mod(const char *iface, i
  * negative otherwise.
  **/
 int rule_add(const char *iface, uint8_t table,
-	     uint32_t priority, uint8_t action,
+	     uint32_t priority, uint32_t fwmark, uint8_t action,
 	     const struct in6_addr *src, int src_plen,
 	     const struct in6_addr *dst, int dst_plen, int flags)
 {
 	return rule_mod(iface, RTM_NEWRULE, table,
-			priority, action,
+			priority, fwmark, action,
 			src, src_plen, dst, dst_plen, flags);
 }
 
@@ -370,12 +372,12 @@ int rule_add(const char *iface, uint8_t 
  * otherwise.
  **/
 int rule_del(const char *iface, uint8_t table,
-	     uint32_t priority, uint8_t action,
+	     uint32_t priority, uint32_t fwmark, uint8_t action,
 	     const struct in6_addr *src, int src_plen,
 	     const struct in6_addr *dst, int dst_plen, int flags)
 {
 	return rule_mod(iface, RTM_DELRULE, table,
-			priority, action,
+			priority, fwmark, action,
 			src, src_plen, dst, dst_plen, flags);
 }
 
diff -r 82fcd4bea972 src/rtnl.h
--- a/src/rtnl.h	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/rtnl.h	Fri Jan 11 17:02:25 2008 +0100
@@ -17,11 +17,14 @@
 #define IP6_RT_PRIO_ADDRCONF 256
 
 #define IP6_RULE_PRIO_MIP6_MNP_IN    1000
-#define IP6_RULE_PRIO_MIP6_HOA_OUT   1001
-#define IP6_RULE_PRIO_MIP6_COA_OUT   1002
-#define IP6_RULE_PRIO_MIP6_BLOCK     1003
-#define IP6_RULE_PRIO_MIP6_BLOCK_HOA 1004
-#define IP6_RULE_PRIO_MIP6_FWD       1005
+#define IP6_RULE_PRIO_MIP6_HOA_OUT_MCOA   1001
+#define IP6_RULE_PRIO_MIP6_HOA_OUT   1002
+#define IP6_RULE_PRIO_MIP6_COA_OUT   1003
+#define IP6_RULE_PRIO_MIP6_BLOCK     1004
+#define IP6_RULE_PRIO_MIP6_BLOCK_HOA 1005
+#define IP6_RULE_PRIO_MIP6_FWD_FWM   1006
+#define IP6_RULE_PRIO_MIP6_FWD_MCOA  1007
+#define IP6_RULE_PRIO_MIP6_FWD       1008
 
 static inline int rtnl_route_open(struct rtnl_handle *rth, 
 				  unsigned subscriptions)
@@ -74,12 +77,12 @@ int route_del(int oif, uint8_t table, ui
 	      const struct in6_addr *gateway);
 
 int rule_add(const char *iface, uint8_t table,
-	     uint32_t priority, uint8_t action,
+	     uint32_t priority, uint32_t fwmark, uint8_t action,
 	     const struct in6_addr *src, int src_plen,
 	     const struct in6_addr *dst, int dst_plen, int flags);
 
 int rule_del(const char *iface, uint8_t table,
-	     uint32_t priority, uint8_t action,
+	     uint32_t priority, uint32_t fwmark, uint8_t action,
 	     const struct in6_addr *src, int src_plen,
 	     const struct in6_addr *dst, int dst_plen,int flags);
 
diff -r 82fcd4bea972 src/scan.l
--- a/src/scan.l	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/scan.l	Fri Jan 11 17:02:25 2008 +0100
@@ -137,7 +137,15 @@ MnDiscardHaParamProb		{ return MNDISCARD
 MnDiscardHaParamProb		{ return MNDISCARDHAPARAMPROB; }
 OptimisticHandoff		{ return OPTIMISTICHANDOFF; }
 HaAcceptMobRtr   		{ return HAACCEPTMOBRTR; }
+HaAcceptMCoAReg			{ return HAACCEPTMCOAREG; }
+MCoAReg				{ return MCOAREG; }
+NoMCoAReg			{ return NOMCOAREG; }
 IsMobRtr       			{ return ISMOBRTR; }
+Bid				{ return BID; }
+BidPriority			{ return BIDPRIORITY; }
+Reliable			{ return RELIABLE; }
+RegMultipleCoA			{ return REGMULTIPLECOA; }
+IfMultipleCoA			{ return IFMULTIPLECOA; }
 HaServedPrefix       	       	{ return HASERVEDPREFIX; }
 HomePrefix     			{ return HOMEPREFIX; }
 MobRtrUseExplicitMode    	{ return MOBRTRUSEEXPLICITMODE; }
diff -r 82fcd4bea972 src/tunnelctl.c
--- a/src/tunnelctl.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/tunnelctl.c	Fri Jan 11 17:02:25 2008 +0100
@@ -157,7 +157,7 @@ static int __tunnel_del(struct mip6_tnl 
 	if (tnl->users == 0) {
 		struct ifreq ifr;
 		list_del(&tnl->list);
-		hash_delete(&tnl_hash, &tnl->parm.laddr, &tnl->parm.raddr);
+		hash_delete(&tnl_hash, &tnl->parm.laddr, &tnl->parm.raddr, 0);
 		strcpy(ifr.ifr_name, tnl->parm.name);
 		if ((res = ioctl(tnl_fd, SIOCDELTUNNEL, &ifr)) < 0) {
 			TDBG("SIOCDELTUNNEL failed status %d %s\n", 
@@ -249,7 +249,7 @@ static struct mip6_tnl *__tunnel_add(str
 		TDBG("no device called %s\n", tnl->parm.name);
 		goto err;
 	}
-	if (hash_add(&tnl_hash, tnl, &tnl->parm.laddr, &tnl->parm.raddr) < 0)
+	if (hash_add(&tnl_hash, tnl, &tnl->parm.laddr, &tnl->parm.raddr, NULL) < 0)
 		goto err;
 	
 	list_add_tail(&tnl->list, &tnl_list);
@@ -287,7 +287,7 @@ int tunnel_add(struct in6_addr *local,
 	int res;
 
 	pthread_mutex_lock(&tnl_lock);
-	if ((tnl = hash_get(&tnl_hash, local, remote)) != NULL) { 
+	if ((tnl = hash_get(&tnl_hash, local, remote, 0)) != NULL) { 
 		tnl->users++;
 		TDBG("tunnel %s (%d) from %x:%x:%x:%x:%x:%x:%x:%x "
 		     "to %x:%x:%x:%x:%x:%x:%x:%x user count increased to %d\n",
@@ -339,9 +339,10 @@ static int __tunnel_mod(struct mip6_tnl 
 		     errno, strerror(errno));
 		return -1;
 	}
-	hash_delete(&tnl_hash, &tnl->parm.laddr, &tnl->parm.raddr);
+	hash_delete(&tnl_hash, &tnl->parm.laddr, &tnl->parm.raddr, 0);
 	memcpy(&tnl->parm, &parm, sizeof(struct ip6_tnl_parm));
-	if (hash_add(&tnl_hash, tnl, &tnl->parm.laddr, &tnl->parm.raddr) < 0) {
+	if (hash_add(&tnl_hash, tnl, &tnl->parm.laddr, 
+		     &tnl->parm.raddr, NULL) < 0) {
 		free(tnl);
 		return -1;
 	}
@@ -387,7 +388,7 @@ int tunnel_mod(int ifindex,
 	old = get_tnl(ifindex);
 	assert(old != NULL);
 
-	if ((new = hash_get(&tnl_hash, local, remote)) != NULL) {
+	if ((new = hash_get(&tnl_hash, local, remote, 0)) != NULL) {
 		if (new != old) {
 			new->users++;
 			TDBG("tunnel %s (%d) from %x:%x:%x:%x:%x:%x:%x:%x "
@@ -448,7 +449,7 @@ static int tnl_cleanup(void *data, void 
 {
 	struct mip6_tnl *tnl = (struct mip6_tnl *) data;
 	list_del(&tnl->list);
-	hash_delete(&tnl_hash, &tnl->parm.laddr, &tnl->parm.raddr);
+	hash_delete(&tnl_hash, &tnl->parm.laddr, &tnl->parm.raddr, 0);
 	free(tnl);
 	return 0;
 }
diff -r 82fcd4bea972 src/vt.c
--- a/src/vt.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/vt.c	Fri Jan 11 17:02:25 2008 +0100
@@ -428,6 +428,12 @@ static int bul_vt_dump(void *data, void 
 		fprintf(vh->vh_stream, " last_coa %x:%x:%x:%x:%x:%x:%x:%x",
 			  NIP6ADDR(&bule->last_coa));
 
+		if (bule->bid) {
+			fprintf(vh->vh_stream, " BID %d", bule->bid);
+			fprintf(vh->vh_stream, " BidPriority %d", 
+				bule->priority);
+		}
+
 		fprintf(vh->vh_stream, "\n");
 
 		if (!(bule->flags & IP6_MH_BU_HOME)) {
@@ -579,6 +585,11 @@ static int bcache_vt_dump(void *data, vo
 
 	fprintf(vh->vh_stream, " coa %x:%x:%x:%x:%x:%x:%x:%x",
 		NIP6ADDR(&bce->coa));
+
+	if (bce->bid) {
+		fprintf(vh->vh_stream, " BID %d", bce->bid);
+		fprintf(vh->vh_stream, " BidPriority %d", bce->priority);
+	}
 
 	if (vh->vh_opt.verbose == VT_BOOL_TRUE)
 		fprintf(vh->vh_stream, " nonce %u", bce->nonce_coa);
